package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingTipoPtoVtaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.GP_PricingTipoPtoVtaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingTipoPtoVtaService")
public class GP_PricingTipoPtoVtaServiceImpl implements GP_PricingTipoPtoVtaService {

    @Autowired
    private GP_PricingTipoPtoVtaDAO pricingTipoPtoVtaDAO;

    public List<GP_PricingTipoPtoVta> obtenerTodos() {
        return pricingTipoPtoVtaDAO.obtenerTodos();
    }

    public GP_PricingTipoPtoVta obtenerID(Integer id) {
        return pricingTipoPtoVtaDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingTipoPtoVta suscribir(GP_PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingTipoPtoVtaDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingTipoPtoVta actualizacion(GP_PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingTipoPtoVtaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingTipoPtoVtaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingTipoPuntoVenta(GP_Pricing pricing, TipoPuntoVenta tipoPuntoVenta) {
        return pricingTipoPtoVtaDAO.obtenerPricingTipoPuntoVenta(pricing, tipoPuntoVenta);
    }

	@Override
	public List<GP_PricingTipoPtoVta> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingTipoPtoVtaDAO.obtenerTodoPorPricing(pricing);
	}
}
